/* NodeGroup.c generated by valac 0.56.14, the Vala compiler
 * generated from NodeGroup.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <libxml/tree.h>
#include <cairo-gobject.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NODE_POINT (node_point_get_type ())
typedef struct _NodePoint NodePoint;
typedef enum  {
	GROUP_MODE_NONE = 0,
	GROUP_MODE_SELECTED
} GroupMode;

#define TYPE_GROUP_MODE (group_mode_get_type ())

#define TYPE_NODE_GROUP (node_group_get_type ())
#define NODE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_GROUP, NodeGroup))
#define NODE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_GROUP, NodeGroupClass))
#define IS_NODE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_GROUP))
#define IS_NODE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_GROUP))
#define NODE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_GROUP, NodeGroupClass))

typedef struct _NodeGroup NodeGroup;
typedef struct _NodeGroupClass NodeGroupClass;
typedef struct _NodeGroupPrivate NodeGroupPrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())
typedef struct _ParamSpecNodeGroup ParamSpecNodeGroup;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NodePoint {
	gdouble x;
	gdouble y;
};

struct _NodeGroup {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NodeGroupPrivate * priv;
};

struct _NodeGroupClass {
	GTypeClass parent_class;
	void (*finalize) (NodeGroup *self);
};

struct _NodeGroupPrivate {
	GArray* _nodes;
	GroupMode _mode;
	GdkRGBA _color;
	gchar* _note;
};

struct _ParamSpecNodeGroup {
	GParamSpec parent_instance;
};

static gint NodeGroup_private_offset;
static gpointer node_group_parent_class = NULL;

VALA_EXTERN GType node_point_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NodePoint* node_point_dup (const NodePoint* self);
VALA_EXTERN void node_point_free (NodePoint* self);
VALA_EXTERN void node_point_init (NodePoint *self,
                      gdouble x,
                      gdouble y);
VALA_EXTERN GType group_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer node_group_ref (gpointer instance);
VALA_EXTERN void node_group_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_node_group (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_node_group (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_node_group (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_node_group (const GValue* value);
VALA_EXTERN GType node_group_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NodeGroup, node_group_unref)
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN NodeGroup* node_group_new (DrawArea* da,
                           Node* node);
VALA_EXTERN NodeGroup* node_group_construct (GType object_type,
                                 DrawArea* da,
                                 Node* node);
VALA_EXTERN GdkRGBA* node_get_link_color (Node* self);
static GdkRGBA* _vala_GdkRGBA_copy (GdkRGBA* self);
VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN Theme* draw_area_get_theme (DrawArea* self);
VALA_EXTERN GdkRGBA* theme_get_color (Theme* self,
                          const gchar* name);
static void _vala_GdkRGBA_free (GdkRGBA* self);
VALA_EXTERN void node_group_set_color (NodeGroup* self,
                           GdkRGBA * value);
static void _g_object_unref0_ (gpointer var);
static void _vala_Node_free_function_content_of (gpointer data);
VALA_EXTERN void node_group_add_node (NodeGroup* self,
                          Node* node);
VALA_EXTERN NodeGroup* node_group_new_array (DrawArea* da,
                                 GArray* nodes);
VALA_EXTERN NodeGroup* node_group_construct_array (GType object_type,
                                       DrawArea* da,
                                       GArray* nodes);
VALA_EXTERN NodeGroup* node_group_new_copy (NodeGroup* group);
VALA_EXTERN NodeGroup* node_group_construct_copy (GType object_type,
                                      NodeGroup* group);
VALA_EXTERN void node_group_get_color (NodeGroup* self,
                           GdkRGBA * result);
VALA_EXTERN NodeGroup* node_group_new_from_xml (DrawArea* da,
                                    xmlNode* n);
VALA_EXTERN NodeGroup* node_group_construct_from_xml (GType object_type,
                                          DrawArea* da,
                                          xmlNode* n);
VALA_EXTERN void node_group_load (NodeGroup* self,
                      DrawArea* da,
                      xmlNode* g);
VALA_EXTERN gboolean node_is_descendant_of (Node* self,
                                Node* node);
VALA_EXTERN void node_set_group (Node* self,
                     gboolean value);
VALA_EXTERN gboolean node_group_remove_node (NodeGroup* self,
                                 Node* node);
VALA_EXTERN void node_group_merge (NodeGroup* self,
                       NodeGroup* other);
VALA_EXTERN gboolean node_group_is_within (NodeGroup* self,
                               gdouble x,
                               gdouble y);
static void _node_point_free0_ (gpointer var);
static void _vala_NodePoint_free_function_content_of (gpointer data);
VALA_EXTERN void node_group_get_tree_points (Node* origin,
                                 Node* node,
                                 GArray* points);
VALA_EXTERN void node_group_get_convex_hull (GArray* points,
                                 GArray* hull);
VALA_EXTERN xmlNode* node_group_save (NodeGroup* self);
VALA_EXTERN gchar* utils_color_from_rgba (GdkRGBA* rgba);
VALA_EXTERN gint node_id (Node* self);
VALA_EXTERN const gchar* node_group_get_note (NodeGroup* self);
static void node_group_load_node (NodeGroup* self,
                           DrawArea* da,
                           xmlNode* n);
static void node_group_load_note (NodeGroup* self,
                           xmlNode* n);
VALA_EXTERN Node* draw_area_get_node (DrawArea* self,
                          GArray* nodes,
                          gint id);
VALA_EXTERN GArray* draw_area_get_nodes (DrawArea* self);
VALA_EXTERN void node_group_set_note (NodeGroup* self,
                          const gchar* value);
VALA_EXTERN void node_group_draw (NodeGroup* self,
                      cairo_t* ctx,
                      Theme* theme,
                      gboolean exporting);
VALA_EXTERN GroupMode node_group_get_mode (NodeGroup* self);
VALA_EXTERN gdouble node_get_alpha (Node* self);
static void node_group_draw_cloud (cairo_t* ctx,
                            GdkRGBA* color,
                            gboolean selected,
                            gdouble alpha,
                            GArray* points);
VALA_EXTERN void node_group_draw_tree (cairo_t* ctx,
                           Node* node,
                           Theme* theme);
VALA_EXTERN void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
VALA_EXTERN void node_group_add_node_points (GArray* points,
                                 Node* node,
                                 gint pad);
VALA_EXTERN gdouble node_get_posx (Node* self);
VALA_EXTERN gdouble node_get_posy (Node* self);
VALA_EXTERN gdouble node_get_width (Node* self);
VALA_EXTERN gdouble node_get_height (Node* self);
VALA_EXTERN gboolean node_get_folded (Node* self);
VALA_EXTERN void node_fold_bbox (Node* self,
                     gdouble* x,
                     gdouble* y,
                     gdouble* w,
                     gdouble* h);
VALA_EXTERN GType node_side_get_type (void) G_GNUC_CONST ;
VALA_EXTERN NodeSide node_get_side (Node* self);
VALA_EXTERN Node* node_folded_ancestor (Node* self);
VALA_EXTERN gint node_groups_between (Node* self,
                          Node* node);
VALA_EXTERN GArray* node_children (Node* self);
VALA_EXTERN gint node_group_calc_orientation (NodePoint* p,
                                  NodePoint* q,
                                  NodePoint* r);
VALA_EXTERN void node_group_set_mode (NodeGroup* self,
                          GroupMode value);
VALA_EXTERN GArray* node_group_get_nodes (NodeGroup* self);
static void node_group_finalize (NodeGroup * obj);
static GType node_group_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

void
node_point_init (NodePoint *self,
                 gdouble x,
                 gdouble y)
{
#line 29 "../src/NodeGroup.vala"
	memset (self, 0, sizeof (NodePoint));
#line 30 "../src/NodeGroup.vala"
	(*self).x = x;
#line 31 "../src/NodeGroup.vala"
	(*self).y = y;
#line 298 "NodeGroup.c"
}

NodePoint*
node_point_dup (const NodePoint* self)
{
	NodePoint* dup;
#line 26 "../src/NodeGroup.vala"
	dup = g_new0 (NodePoint, 1);
#line 26 "../src/NodeGroup.vala"
	memcpy (dup, self, sizeof (NodePoint));
#line 26 "../src/NodeGroup.vala"
	return dup;
#line 311 "NodeGroup.c"
}

void
node_point_free (NodePoint* self)
{
#line 26 "../src/NodeGroup.vala"
	g_free (self);
#line 319 "NodeGroup.c"
}

static GType
node_point_get_type_once (void)
{
	GType node_point_type_id;
	node_point_type_id = g_boxed_type_register_static ("NodePoint", (GBoxedCopyFunc) node_point_dup, (GBoxedFreeFunc) node_point_free);
	return node_point_type_id;
}

GType
node_point_get_type (void)
{
	static volatile gsize node_point_type_id__once = 0;
	if (g_once_init_enter (&node_point_type_id__once)) {
		GType node_point_type_id;
		node_point_type_id = node_point_get_type_once ();
		g_once_init_leave (&node_point_type_id__once, node_point_type_id);
	}
	return node_point_type_id__once;
}

static GType
group_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GROUP_MODE_NONE, "GROUP_MODE_NONE", "none"}, {GROUP_MODE_SELECTED, "GROUP_MODE_SELECTED", "selected"}, {0, NULL, NULL}};
	GType group_mode_type_id;
	group_mode_type_id = g_enum_register_static ("GroupMode", values);
	return group_mode_type_id;
}

GType
group_mode_get_type (void)
{
	static volatile gsize group_mode_type_id__once = 0;
	if (g_once_init_enter (&group_mode_type_id__once)) {
		GType group_mode_type_id;
		group_mode_type_id = group_mode_get_type_once ();
		g_once_init_leave (&group_mode_type_id__once, group_mode_type_id);
	}
	return group_mode_type_id__once;
}

static inline gpointer
node_group_get_instance_private (NodeGroup* self)
{
	return G_STRUCT_MEMBER_P (self, NodeGroup_private_offset);
}

static GdkRGBA*
_vala_GdkRGBA_copy (GdkRGBA* self)
{
#line 55 "../src/NodeGroup.vala"
	return g_boxed_copy (gdk_rgba_get_type (), self);
#line 374 "NodeGroup.c"
}

static gpointer
__vala_GdkRGBA_copy0 (gpointer self)
{
#line 55 "../src/NodeGroup.vala"
	return self ? _vala_GdkRGBA_copy (self) : NULL;
#line 382 "NodeGroup.c"
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
#line 55 "../src/NodeGroup.vala"
	g_boxed_free (gdk_rgba_get_type (), self);
#line 390 "NodeGroup.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 56 "../src/NodeGroup.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 398 "NodeGroup.c"
}

static void
_vala_Node_free_function_content_of (gpointer data)
{
	Node* self;
#line 56 "../src/NodeGroup.vala"
	self = *((Node**) data);
#line 56 "../src/NodeGroup.vala"
	_g_object_unref0_ (self);
#line 409 "NodeGroup.c"
}

NodeGroup*
node_group_construct (GType object_type,
                      DrawArea* da,
                      Node* node)
{
	NodeGroup* self = NULL;
	GdkRGBA* _tmp0_ = NULL;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	GdkRGBA* _tmp3_;
	GdkRGBA _tmp7_;
	GArray* _tmp8_;
#line 54 "../src/NodeGroup.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 54 "../src/NodeGroup.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 54 "../src/NodeGroup.vala"
	self = (NodeGroup*) g_type_create_instance (object_type);
#line 55 "../src/NodeGroup.vala"
	_tmp1_ = node_get_link_color (node);
#line 55 "../src/NodeGroup.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/NodeGroup.vala"
	_tmp3_ = __vala_GdkRGBA_copy0 (_tmp2_);
#line 55 "../src/NodeGroup.vala"
	_tmp0_ = _tmp3_;
#line 55 "../src/NodeGroup.vala"
	if (_tmp0_ == NULL) {
#line 440 "NodeGroup.c"
		Theme* _tmp4_;
		Theme* _tmp5_;
		GdkRGBA* _tmp6_;
#line 55 "../src/NodeGroup.vala"
		_tmp4_ = draw_area_get_theme (da);
#line 55 "../src/NodeGroup.vala"
		_tmp5_ = _tmp4_;
#line 55 "../src/NodeGroup.vala"
		_tmp6_ = theme_get_color (_tmp5_, "root_background");
#line 55 "../src/NodeGroup.vala"
		__vala_GdkRGBA_free0 (_tmp0_);
#line 55 "../src/NodeGroup.vala"
		_tmp0_ = _tmp6_;
#line 55 "../src/NodeGroup.vala"
		_g_object_unref0 (_tmp5_);
#line 456 "NodeGroup.c"
	}
#line 55 "../src/NodeGroup.vala"
	_tmp7_ = *_tmp0_;
#line 55 "../src/NodeGroup.vala"
	node_group_set_color (self, &_tmp7_);
#line 56 "../src/NodeGroup.vala"
	_tmp8_ = g_array_new (TRUE, TRUE, sizeof (Node*));
#line 56 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp8_, (GDestroyNotify) _vala_Node_free_function_content_of);
#line 56 "../src/NodeGroup.vala"
	_g_array_unref0 (self->priv->_nodes);
#line 56 "../src/NodeGroup.vala"
	self->priv->_nodes = _tmp8_;
#line 57 "../src/NodeGroup.vala"
	node_group_add_node (self, node);
#line 54 "../src/NodeGroup.vala"
	__vala_GdkRGBA_free0 (_tmp0_);
#line 54 "../src/NodeGroup.vala"
	return self;
#line 476 "NodeGroup.c"
}

NodeGroup*
node_group_new (DrawArea* da,
                Node* node)
{
#line 54 "../src/NodeGroup.vala"
	return node_group_construct (TYPE_NODE_GROUP, da, node);
#line 485 "NodeGroup.c"
}

NodeGroup*
node_group_construct_array (GType object_type,
                            DrawArea* da,
                            GArray* nodes)
{
	NodeGroup* self = NULL;
	GdkRGBA* _tmp0_ = NULL;
	Node* _tmp1_;
	GdkRGBA* _tmp2_;
	GdkRGBA* _tmp3_;
	GdkRGBA* _tmp4_;
	GdkRGBA _tmp8_;
	GArray* _tmp9_;
#line 61 "../src/NodeGroup.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 61 "../src/NodeGroup.vala"
	g_return_val_if_fail (nodes != NULL, NULL);
#line 61 "../src/NodeGroup.vala"
	self = (NodeGroup*) g_type_create_instance (object_type);
#line 62 "../src/NodeGroup.vala"
	_tmp1_ = g_array_index (nodes, Node*, (guint) 0);
#line 62 "../src/NodeGroup.vala"
	_tmp2_ = node_get_link_color (_tmp1_);
#line 62 "../src/NodeGroup.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/NodeGroup.vala"
	_tmp4_ = __vala_GdkRGBA_copy0 (_tmp3_);
#line 62 "../src/NodeGroup.vala"
	_tmp0_ = _tmp4_;
#line 62 "../src/NodeGroup.vala"
	if (_tmp0_ == NULL) {
#line 519 "NodeGroup.c"
		Theme* _tmp5_;
		Theme* _tmp6_;
		GdkRGBA* _tmp7_;
#line 62 "../src/NodeGroup.vala"
		_tmp5_ = draw_area_get_theme (da);
#line 62 "../src/NodeGroup.vala"
		_tmp6_ = _tmp5_;
#line 62 "../src/NodeGroup.vala"
		_tmp7_ = theme_get_color (_tmp6_, "root_background");
#line 62 "../src/NodeGroup.vala"
		__vala_GdkRGBA_free0 (_tmp0_);
#line 62 "../src/NodeGroup.vala"
		_tmp0_ = _tmp7_;
#line 62 "../src/NodeGroup.vala"
		_g_object_unref0 (_tmp6_);
#line 535 "NodeGroup.c"
	}
#line 62 "../src/NodeGroup.vala"
	_tmp8_ = *_tmp0_;
#line 62 "../src/NodeGroup.vala"
	node_group_set_color (self, &_tmp8_);
#line 63 "../src/NodeGroup.vala"
	_tmp9_ = g_array_new (TRUE, TRUE, sizeof (Node*));
#line 63 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp9_, (GDestroyNotify) _vala_Node_free_function_content_of);
#line 63 "../src/NodeGroup.vala"
	_g_array_unref0 (self->priv->_nodes);
#line 63 "../src/NodeGroup.vala"
	self->priv->_nodes = _tmp9_;
#line 549 "NodeGroup.c"
	{
		gint i = 0;
#line 64 "../src/NodeGroup.vala"
		i = 0;
#line 554 "NodeGroup.c"
		{
			gboolean _tmp10_ = FALSE;
#line 64 "../src/NodeGroup.vala"
			_tmp10_ = TRUE;
#line 64 "../src/NodeGroup.vala"
			while (TRUE) {
#line 561 "NodeGroup.c"
				Node* _tmp12_;
#line 64 "../src/NodeGroup.vala"
				if (!_tmp10_) {
#line 565 "NodeGroup.c"
					gint _tmp11_;
#line 64 "../src/NodeGroup.vala"
					_tmp11_ = i;
#line 64 "../src/NodeGroup.vala"
					i = _tmp11_ + 1;
#line 571 "NodeGroup.c"
				}
#line 64 "../src/NodeGroup.vala"
				_tmp10_ = FALSE;
#line 64 "../src/NodeGroup.vala"
				if (!(((guint) i) < nodes->len)) {
#line 64 "../src/NodeGroup.vala"
					break;
#line 579 "NodeGroup.c"
				}
#line 65 "../src/NodeGroup.vala"
				_tmp12_ = g_array_index (nodes, Node*, (guint) i);
#line 65 "../src/NodeGroup.vala"
				node_group_add_node (self, _tmp12_);
#line 585 "NodeGroup.c"
			}
		}
	}
#line 61 "../src/NodeGroup.vala"
	__vala_GdkRGBA_free0 (_tmp0_);
#line 61 "../src/NodeGroup.vala"
	return self;
#line 593 "NodeGroup.c"
}

NodeGroup*
node_group_new_array (DrawArea* da,
                      GArray* nodes)
{
#line 61 "../src/NodeGroup.vala"
	return node_group_construct_array (TYPE_NODE_GROUP, da, nodes);
#line 602 "NodeGroup.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 74 "../src/NodeGroup.vala"
	return self ? g_object_ref (self) : NULL;
#line 610 "NodeGroup.c"
}

NodeGroup*
node_group_construct_copy (GType object_type,
                           NodeGroup* group)
{
	NodeGroup* self = NULL;
	GdkRGBA _tmp0_;
	GArray* _tmp1_;
#line 70 "../src/NodeGroup.vala"
	g_return_val_if_fail (group != NULL, NULL);
#line 70 "../src/NodeGroup.vala"
	self = (NodeGroup*) g_type_create_instance (object_type);
#line 71 "../src/NodeGroup.vala"
	_tmp0_ = group->priv->_color;
#line 71 "../src/NodeGroup.vala"
	node_group_set_color (self, &_tmp0_);
#line 72 "../src/NodeGroup.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (Node*));
#line 72 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_Node_free_function_content_of);
#line 72 "../src/NodeGroup.vala"
	_g_array_unref0 (self->priv->_nodes);
#line 72 "../src/NodeGroup.vala"
	self->priv->_nodes = _tmp1_;
#line 636 "NodeGroup.c"
	{
		gint i = 0;
#line 73 "../src/NodeGroup.vala"
		i = 0;
#line 641 "NodeGroup.c"
		{
			gboolean _tmp2_ = FALSE;
#line 73 "../src/NodeGroup.vala"
			_tmp2_ = TRUE;
#line 73 "../src/NodeGroup.vala"
			while (TRUE) {
#line 648 "NodeGroup.c"
				GArray* _tmp4_;
				GArray* _tmp5_;
				GArray* _tmp6_;
				Node* _tmp7_;
				Node* _tmp8_;
#line 73 "../src/NodeGroup.vala"
				if (!_tmp2_) {
#line 656 "NodeGroup.c"
					gint _tmp3_;
#line 73 "../src/NodeGroup.vala"
					_tmp3_ = i;
#line 73 "../src/NodeGroup.vala"
					i = _tmp3_ + 1;
#line 662 "NodeGroup.c"
				}
#line 73 "../src/NodeGroup.vala"
				_tmp2_ = FALSE;
#line 73 "../src/NodeGroup.vala"
				_tmp4_ = group->priv->_nodes;
#line 73 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp4_->len)) {
#line 73 "../src/NodeGroup.vala"
					break;
#line 672 "NodeGroup.c"
				}
#line 74 "../src/NodeGroup.vala"
				_tmp5_ = self->priv->_nodes;
#line 74 "../src/NodeGroup.vala"
				_tmp6_ = group->priv->_nodes;
#line 74 "../src/NodeGroup.vala"
				_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 74 "../src/NodeGroup.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 74 "../src/NodeGroup.vala"
				g_array_append_val (_tmp5_, _tmp8_);
#line 684 "NodeGroup.c"
			}
		}
	}
#line 70 "../src/NodeGroup.vala"
	return self;
#line 690 "NodeGroup.c"
}

NodeGroup*
node_group_new_copy (NodeGroup* group)
{
#line 70 "../src/NodeGroup.vala"
	return node_group_construct_copy (TYPE_NODE_GROUP, group);
#line 698 "NodeGroup.c"
}

NodeGroup*
node_group_construct_from_xml (GType object_type,
                               DrawArea* da,
                               xmlNode* n)
{
	NodeGroup* self = NULL;
	GArray* _tmp0_;
#line 79 "../src/NodeGroup.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 79 "../src/NodeGroup.vala"
	self = (NodeGroup*) g_type_create_instance (object_type);
#line 80 "../src/NodeGroup.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (Node*));
#line 80 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_Node_free_function_content_of);
#line 80 "../src/NodeGroup.vala"
	_g_array_unref0 (self->priv->_nodes);
#line 80 "../src/NodeGroup.vala"
	self->priv->_nodes = _tmp0_;
#line 81 "../src/NodeGroup.vala"
	node_group_load (self, da, n);
#line 79 "../src/NodeGroup.vala"
	return self;
#line 724 "NodeGroup.c"
}

NodeGroup*
node_group_new_from_xml (DrawArea* da,
                         xmlNode* n)
{
#line 79 "../src/NodeGroup.vala"
	return node_group_construct_from_xml (TYPE_NODE_GROUP, da, n);
#line 733 "NodeGroup.c"
}

static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer g = NULL;
	gpointer* _tmp0_;
	gint _tmp0__length1;
	gpointer _tmp1_;
	gpointer result;
#line 6137 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 6138 "glib-2.0.vapi"
	_vala_assert (self->len > index, "length > index");
#line 6139 "glib-2.0.vapi"
	_tmp0_ = self->data;
#line 6139 "glib-2.0.vapi"
	_tmp0__length1 = self->len;
#line 6139 "glib-2.0.vapi"
	_tmp1_ = _tmp0_[index];
#line 6139 "glib-2.0.vapi"
	_tmp0_[index] = NULL;
#line 6139 "glib-2.0.vapi"
	g = _tmp1_;
#line 6140 "glib-2.0.vapi"
	g_array_remove_index (self, index);
#line 6141 "glib-2.0.vapi"
	result = g;
#line 6141 "glib-2.0.vapi"
	return result;
#line 765 "NodeGroup.c"
}

void
node_group_add_node (NodeGroup* self,
                     Node* node)
{
	GArray* _tmp13_;
	Node* _tmp14_;
#line 85 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/NodeGroup.vala"
	g_return_if_fail (node != NULL);
#line 778 "NodeGroup.c"
	{
		gint i = 0;
#line 86 "../src/NodeGroup.vala"
		i = 0;
#line 783 "NodeGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 86 "../src/NodeGroup.vala"
			_tmp0_ = TRUE;
#line 86 "../src/NodeGroup.vala"
			while (TRUE) {
#line 790 "NodeGroup.c"
				GArray* _tmp2_;
				Node* n = NULL;
				GArray* _tmp3_;
				Node* _tmp4_;
				Node* _tmp5_;
				Node* _tmp6_;
#line 86 "../src/NodeGroup.vala"
				if (!_tmp0_) {
#line 799 "NodeGroup.c"
					gint _tmp1_;
#line 86 "../src/NodeGroup.vala"
					_tmp1_ = i;
#line 86 "../src/NodeGroup.vala"
					i = _tmp1_ + 1;
#line 805 "NodeGroup.c"
				}
#line 86 "../src/NodeGroup.vala"
				_tmp0_ = FALSE;
#line 86 "../src/NodeGroup.vala"
				_tmp2_ = self->priv->_nodes;
#line 86 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp2_->len)) {
#line 86 "../src/NodeGroup.vala"
					break;
#line 815 "NodeGroup.c"
				}
#line 87 "../src/NodeGroup.vala"
				_tmp3_ = self->priv->_nodes;
#line 87 "../src/NodeGroup.vala"
				_tmp4_ = g_array_index (_tmp3_, Node*, (guint) i);
#line 87 "../src/NodeGroup.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 87 "../src/NodeGroup.vala"
				n = _tmp5_;
#line 88 "../src/NodeGroup.vala"
				_tmp6_ = n;
#line 88 "../src/NodeGroup.vala"
				if (node_is_descendant_of (_tmp6_, node)) {
#line 829 "NodeGroup.c"
					GArray* _tmp7_;
					Node* _tmp8_;
					GArray* _tmp9_;
					Node* _tmp10_;
					Node* _tmp11_;
#line 89 "../src/NodeGroup.vala"
					_tmp7_ = self->priv->_nodes;
#line 89 "../src/NodeGroup.vala"
					_tmp8_ = g_array_index (_tmp7_, Node*, (guint) i);
#line 89 "../src/NodeGroup.vala"
					node_set_group (_tmp8_, FALSE);
#line 90 "../src/NodeGroup.vala"
					_tmp9_ = self->priv->_nodes;
#line 90 "../src/NodeGroup.vala"
					_tmp10_ = vala_g_array_remove_index (_tmp9_, (guint) i);
#line 90 "../src/NodeGroup.vala"
					_tmp11_ = _tmp10_;
#line 90 "../src/NodeGroup.vala"
					_g_object_unref0 (_tmp11_);
#line 849 "NodeGroup.c"
				} else {
					Node* _tmp12_;
#line 91 "../src/NodeGroup.vala"
					_tmp12_ = n;
#line 91 "../src/NodeGroup.vala"
					if (node_is_descendant_of (node, _tmp12_)) {
#line 92 "../src/NodeGroup.vala"
						_g_object_unref0 (n);
#line 92 "../src/NodeGroup.vala"
						return;
#line 860 "NodeGroup.c"
					}
				}
#line 86 "../src/NodeGroup.vala"
				_g_object_unref0 (n);
#line 865 "NodeGroup.c"
			}
		}
	}
#line 95 "../src/NodeGroup.vala"
	node_set_group (node, TRUE);
#line 96 "../src/NodeGroup.vala"
	_tmp13_ = self->priv->_nodes;
#line 96 "../src/NodeGroup.vala"
	_tmp14_ = _g_object_ref0 (node);
#line 96 "../src/NodeGroup.vala"
	g_array_append_val (_tmp13_, _tmp14_);
#line 877 "NodeGroup.c"
}

gboolean
node_group_remove_node (NodeGroup* self,
                        Node* node)
{
	gboolean result;
#line 100 "../src/NodeGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../src/NodeGroup.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 889 "NodeGroup.c"
	{
		gint i = 0;
#line 101 "../src/NodeGroup.vala"
		i = 0;
#line 894 "NodeGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 101 "../src/NodeGroup.vala"
			_tmp0_ = TRUE;
#line 101 "../src/NodeGroup.vala"
			while (TRUE) {
#line 901 "NodeGroup.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				Node* _tmp4_;
#line 101 "../src/NodeGroup.vala"
				if (!_tmp0_) {
#line 907 "NodeGroup.c"
					gint _tmp1_;
#line 101 "../src/NodeGroup.vala"
					_tmp1_ = i;
#line 101 "../src/NodeGroup.vala"
					i = _tmp1_ + 1;
#line 913 "NodeGroup.c"
				}
#line 101 "../src/NodeGroup.vala"
				_tmp0_ = FALSE;
#line 101 "../src/NodeGroup.vala"
				_tmp2_ = self->priv->_nodes;
#line 101 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp2_->len)) {
#line 101 "../src/NodeGroup.vala"
					break;
#line 923 "NodeGroup.c"
				}
#line 102 "../src/NodeGroup.vala"
				_tmp3_ = self->priv->_nodes;
#line 102 "../src/NodeGroup.vala"
				_tmp4_ = g_array_index (_tmp3_, Node*, (guint) i);
#line 102 "../src/NodeGroup.vala"
				if (_tmp4_ == node) {
#line 931 "NodeGroup.c"
					GArray* _tmp5_;
					Node* _tmp6_;
					Node* _tmp7_;
#line 103 "../src/NodeGroup.vala"
					node_set_group (node, FALSE);
#line 104 "../src/NodeGroup.vala"
					_tmp5_ = self->priv->_nodes;
#line 104 "../src/NodeGroup.vala"
					_tmp6_ = vala_g_array_remove_index (_tmp5_, (guint) i);
#line 104 "../src/NodeGroup.vala"
					_tmp7_ = _tmp6_;
#line 104 "../src/NodeGroup.vala"
					_g_object_unref0 (_tmp7_);
#line 105 "../src/NodeGroup.vala"
					result = TRUE;
#line 105 "../src/NodeGroup.vala"
					return result;
#line 949 "NodeGroup.c"
				}
			}
		}
	}
#line 108 "../src/NodeGroup.vala"
	result = FALSE;
#line 108 "../src/NodeGroup.vala"
	return result;
#line 958 "NodeGroup.c"
}

void
node_group_merge (NodeGroup* self,
                  NodeGroup* other)
{
#line 112 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/NodeGroup.vala"
	g_return_if_fail (other != NULL);
#line 969 "NodeGroup.c"
	{
		gint i = 0;
#line 113 "../src/NodeGroup.vala"
		i = 0;
#line 974 "NodeGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 113 "../src/NodeGroup.vala"
			_tmp0_ = TRUE;
#line 113 "../src/NodeGroup.vala"
			while (TRUE) {
#line 981 "NodeGroup.c"
				GArray* _tmp2_;
				GArray* _tmp3_;
				Node* _tmp4_;
#line 113 "../src/NodeGroup.vala"
				if (!_tmp0_) {
#line 987 "NodeGroup.c"
					gint _tmp1_;
#line 113 "../src/NodeGroup.vala"
					_tmp1_ = i;
#line 113 "../src/NodeGroup.vala"
					i = _tmp1_ + 1;
#line 993 "NodeGroup.c"
				}
#line 113 "../src/NodeGroup.vala"
				_tmp0_ = FALSE;
#line 113 "../src/NodeGroup.vala"
				_tmp2_ = other->priv->_nodes;
#line 113 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp2_->len)) {
#line 113 "../src/NodeGroup.vala"
					break;
#line 1003 "NodeGroup.c"
				}
#line 114 "../src/NodeGroup.vala"
				_tmp3_ = other->priv->_nodes;
#line 114 "../src/NodeGroup.vala"
				_tmp4_ = g_array_index (_tmp3_, Node*, (guint) i);
#line 114 "../src/NodeGroup.vala"
				node_group_add_node (self, _tmp4_);
#line 1011 "NodeGroup.c"
			}
		}
	}
}

static void
_node_point_free0_ (gpointer var)
{
#line 121 "../src/NodeGroup.vala"
	(var == NULL) ? NULL : (var = (node_point_free (var), NULL));
#line 1022 "NodeGroup.c"
}

static void
_vala_NodePoint_free_function_content_of (gpointer data)
{
	NodePoint* self;
#line 121 "../src/NodeGroup.vala"
	self = *((NodePoint**) data);
#line 121 "../src/NodeGroup.vala"
	_node_point_free0_ (self);
#line 1033 "NodeGroup.c"
}

static gpointer
_node_point_dup0 (gpointer self)
{
#line 123 "../src/NodeGroup.vala"
	return self ? node_point_dup (self) : NULL;
#line 1041 "NodeGroup.c"
}

gboolean
node_group_is_within (NodeGroup* self,
                      gdouble x,
                      gdouble y)
{
	NodePoint cursor = {0};
	GArray* points = NULL;
	GArray* _tmp0_;
	GArray* hull = NULL;
	GArray* _tmp1_;
	GArray* _tmp2_;
	NodePoint _tmp3_;
	NodePoint* _tmp4_;
	GArray* _tmp13_;
	GArray* _tmp14_;
	gboolean result;
#line 119 "../src/NodeGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/NodeGroup.vala"
	node_point_init (&cursor, x, y);
#line 121 "../src/NodeGroup.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
#line 121 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
#line 121 "../src/NodeGroup.vala"
	points = _tmp0_;
#line 122 "../src/NodeGroup.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
#line 122 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
#line 122 "../src/NodeGroup.vala"
	hull = _tmp1_;
#line 123 "../src/NodeGroup.vala"
	_tmp2_ = points;
#line 123 "../src/NodeGroup.vala"
	_tmp3_ = cursor;
#line 123 "../src/NodeGroup.vala"
	_tmp4_ = _node_point_dup0 (&_tmp3_);
#line 123 "../src/NodeGroup.vala"
	g_array_append_val (_tmp2_, _tmp4_);
#line 1084 "NodeGroup.c"
	{
		gint i = 0;
#line 124 "../src/NodeGroup.vala"
		i = 0;
#line 1089 "NodeGroup.c"
		{
			gboolean _tmp5_ = FALSE;
#line 124 "../src/NodeGroup.vala"
			_tmp5_ = TRUE;
#line 124 "../src/NodeGroup.vala"
			while (TRUE) {
#line 1096 "NodeGroup.c"
				GArray* _tmp7_;
				GArray* _tmp8_;
				Node* _tmp9_;
				GArray* _tmp10_;
				Node* _tmp11_;
				GArray* _tmp12_;
#line 124 "../src/NodeGroup.vala"
				if (!_tmp5_) {
#line 1105 "NodeGroup.c"
					gint _tmp6_;
#line 124 "../src/NodeGroup.vala"
					_tmp6_ = i;
#line 124 "../src/NodeGroup.vala"
					i = _tmp6_ + 1;
#line 1111 "NodeGroup.c"
				}
#line 124 "../src/NodeGroup.vala"
				_tmp5_ = FALSE;
#line 124 "../src/NodeGroup.vala"
				_tmp7_ = self->priv->_nodes;
#line 124 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp7_->len)) {
#line 124 "../src/NodeGroup.vala"
					break;
#line 1121 "NodeGroup.c"
				}
#line 125 "../src/NodeGroup.vala"
				_tmp8_ = self->priv->_nodes;
#line 125 "../src/NodeGroup.vala"
				_tmp9_ = g_array_index (_tmp8_, Node*, (guint) i);
#line 125 "../src/NodeGroup.vala"
				_tmp10_ = self->priv->_nodes;
#line 125 "../src/NodeGroup.vala"
				_tmp11_ = g_array_index (_tmp10_, Node*, (guint) i);
#line 125 "../src/NodeGroup.vala"
				_tmp12_ = points;
#line 125 "../src/NodeGroup.vala"
				node_group_get_tree_points (_tmp9_, _tmp11_, _tmp12_);
#line 1135 "NodeGroup.c"
			}
		}
	}
#line 127 "../src/NodeGroup.vala"
	_tmp13_ = points;
#line 127 "../src/NodeGroup.vala"
	_tmp14_ = hull;
#line 127 "../src/NodeGroup.vala"
	node_group_get_convex_hull (_tmp13_, _tmp14_);
#line 1145 "NodeGroup.c"
	{
		gint i = 0;
#line 128 "../src/NodeGroup.vala"
		i = 0;
#line 1150 "NodeGroup.c"
		{
			gboolean _tmp15_ = FALSE;
#line 128 "../src/NodeGroup.vala"
			_tmp15_ = TRUE;
#line 128 "../src/NodeGroup.vala"
			while (TRUE) {
#line 1157 "NodeGroup.c"
				GArray* _tmp17_;
				gboolean _tmp18_ = FALSE;
				NodePoint _tmp19_;
				GArray* _tmp20_;
#line 128 "../src/NodeGroup.vala"
				if (!_tmp15_) {
#line 1164 "NodeGroup.c"
					gint _tmp16_;
#line 128 "../src/NodeGroup.vala"
					_tmp16_ = i;
#line 128 "../src/NodeGroup.vala"
					i = _tmp16_ + 1;
#line 1170 "NodeGroup.c"
				}
#line 128 "../src/NodeGroup.vala"
				_tmp15_ = FALSE;
#line 128 "../src/NodeGroup.vala"
				_tmp17_ = hull;
#line 128 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp17_->len)) {
#line 128 "../src/NodeGroup.vala"
					break;
#line 1180 "NodeGroup.c"
				}
#line 129 "../src/NodeGroup.vala"
				_tmp19_ = cursor;
#line 129 "../src/NodeGroup.vala"
				_tmp20_ = hull;
#line 129 "../src/NodeGroup.vala"
				if (_tmp19_.x == (*g_array_index (_tmp20_, NodePoint*, (guint) i)).x) {
#line 1188 "NodeGroup.c"
					NodePoint _tmp21_;
					GArray* _tmp22_;
#line 129 "../src/NodeGroup.vala"
					_tmp21_ = cursor;
#line 129 "../src/NodeGroup.vala"
					_tmp22_ = hull;
#line 129 "../src/NodeGroup.vala"
					_tmp18_ = _tmp21_.y == (*g_array_index (_tmp22_, NodePoint*, (guint) i)).y;
#line 1197 "NodeGroup.c"
				} else {
#line 129 "../src/NodeGroup.vala"
					_tmp18_ = FALSE;
#line 1201 "NodeGroup.c"
				}
#line 129 "../src/NodeGroup.vala"
				if (_tmp18_) {
#line 130 "../src/NodeGroup.vala"
					result = FALSE;
#line 130 "../src/NodeGroup.vala"
					_g_array_unref0 (hull);
#line 130 "../src/NodeGroup.vala"
					_g_array_unref0 (points);
#line 130 "../src/NodeGroup.vala"
					return result;
#line 1213 "NodeGroup.c"
				}
			}
		}
	}
#line 133 "../src/NodeGroup.vala"
	result = TRUE;
#line 133 "../src/NodeGroup.vala"
	_g_array_unref0 (hull);
#line 133 "../src/NodeGroup.vala"
	_g_array_unref0 (points);
#line 133 "../src/NodeGroup.vala"
	return result;
#line 1226 "NodeGroup.c"
}

xmlNode*
node_group_save (NodeGroup* self)
{
	xmlNode* g = NULL;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	GdkRGBA _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	xmlNode* _tmp16_;
	const gchar* _tmp17_;
	xmlNode* _tmp18_;
	xmlNode* result;
#line 137 "../src/NodeGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../src/NodeGroup.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "group");
#line 138 "../src/NodeGroup.vala"
	g = _tmp0_;
#line 139 "../src/NodeGroup.vala"
	_tmp1_ = g;
#line 139 "../src/NodeGroup.vala"
	_tmp2_ = self->priv->_color;
#line 139 "../src/NodeGroup.vala"
	_tmp3_ = utils_color_from_rgba (&_tmp2_);
#line 139 "../src/NodeGroup.vala"
	_tmp4_ = _tmp3_;
#line 139 "../src/NodeGroup.vala"
	xmlSetProp (_tmp1_, (xmlChar*) "color", (xmlChar*) _tmp4_);
#line 139 "../src/NodeGroup.vala"
	_g_free0 (_tmp4_);
#line 1260 "NodeGroup.c"
	{
		gint i = 0;
#line 140 "../src/NodeGroup.vala"
		i = 0;
#line 1265 "NodeGroup.c"
		{
			gboolean _tmp5_ = FALSE;
#line 140 "../src/NodeGroup.vala"
			_tmp5_ = TRUE;
#line 140 "../src/NodeGroup.vala"
			while (TRUE) {
#line 1272 "NodeGroup.c"
				GArray* _tmp7_;
				xmlNode* n = NULL;
				xmlNode* _tmp8_;
				xmlNode* _tmp9_;
				GArray* _tmp10_;
				Node* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				xmlNode* _tmp14_;
				xmlNode* _tmp15_;
#line 140 "../src/NodeGroup.vala"
				if (!_tmp5_) {
#line 1285 "NodeGroup.c"
					gint _tmp6_;
#line 140 "../src/NodeGroup.vala"
					_tmp6_ = i;
#line 140 "../src/NodeGroup.vala"
					i = _tmp6_ + 1;
#line 1291 "NodeGroup.c"
				}
#line 140 "../src/NodeGroup.vala"
				_tmp5_ = FALSE;
#line 140 "../src/NodeGroup.vala"
				_tmp7_ = self->priv->_nodes;
#line 140 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp7_->len)) {
#line 140 "../src/NodeGroup.vala"
					break;
#line 1301 "NodeGroup.c"
				}
#line 141 "../src/NodeGroup.vala"
				_tmp8_ = xmlNewNode (NULL, (xmlChar*) "node");
#line 141 "../src/NodeGroup.vala"
				n = _tmp8_;
#line 142 "../src/NodeGroup.vala"
				_tmp9_ = n;
#line 142 "../src/NodeGroup.vala"
				_tmp10_ = self->priv->_nodes;
#line 142 "../src/NodeGroup.vala"
				_tmp11_ = g_array_index (_tmp10_, Node*, (guint) i);
#line 142 "../src/NodeGroup.vala"
				_tmp12_ = g_strdup_printf ("%i", node_id (_tmp11_));
#line 142 "../src/NodeGroup.vala"
				_tmp13_ = _tmp12_;
#line 142 "../src/NodeGroup.vala"
				xmlSetProp (_tmp9_, (xmlChar*) "id", (xmlChar*) _tmp13_);
#line 142 "../src/NodeGroup.vala"
				_g_free0 (_tmp13_);
#line 143 "../src/NodeGroup.vala"
				_tmp14_ = g;
#line 143 "../src/NodeGroup.vala"
				_tmp15_ = n;
#line 143 "../src/NodeGroup.vala"
				xmlAddChild (_tmp14_, _tmp15_);
#line 1327 "NodeGroup.c"
			}
		}
	}
#line 145 "../src/NodeGroup.vala"
	_tmp16_ = g;
#line 145 "../src/NodeGroup.vala"
	_tmp17_ = self->priv->_note;
#line 145 "../src/NodeGroup.vala"
	xmlNewTextChild (_tmp16_, NULL, (xmlChar*) "groupnote", (xmlChar*) _tmp17_);
#line 146 "../src/NodeGroup.vala"
	_tmp18_ = g;
#line 146 "../src/NodeGroup.vala"
	result = _tmp18_;
#line 146 "../src/NodeGroup.vala"
	return result;
#line 1343 "NodeGroup.c"
}

void
node_group_load (NodeGroup* self,
                 DrawArea* da,
                 xmlNode* g)
{
	gchar* c = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 150 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/NodeGroup.vala"
	g_return_if_fail (da != NULL);
#line 151 "../src/NodeGroup.vala"
	_tmp0_ = (gchar*) xmlGetProp (g, (xmlChar*) "color");
#line 151 "../src/NodeGroup.vala"
	c = _tmp0_;
#line 152 "../src/NodeGroup.vala"
	_tmp1_ = c;
#line 152 "../src/NodeGroup.vala"
	if (_tmp1_ != NULL) {
#line 1366 "NodeGroup.c"
		GdkRGBA clr = {0};
		GdkRGBA _tmp2_ = {0};
		const gchar* _tmp3_;
		GdkRGBA _tmp4_;
#line 153 "../src/NodeGroup.vala"
		_tmp2_.red = 1.0;
#line 153 "../src/NodeGroup.vala"
		_tmp2_.green = 1.0;
#line 153 "../src/NodeGroup.vala"
		_tmp2_.blue = 1.0;
#line 153 "../src/NodeGroup.vala"
		_tmp2_.alpha = 1.0;
#line 153 "../src/NodeGroup.vala"
		clr = _tmp2_;
#line 154 "../src/NodeGroup.vala"
		_tmp3_ = c;
#line 154 "../src/NodeGroup.vala"
		gdk_rgba_parse (&clr, _tmp3_);
#line 155 "../src/NodeGroup.vala"
		_tmp4_ = clr;
#line 155 "../src/NodeGroup.vala"
		node_group_set_color (self, &_tmp4_);
#line 1389 "NodeGroup.c"
	}
	{
		xmlNode* it = NULL;
		xmlNode* _tmp5_;
#line 157 "../src/NodeGroup.vala"
		_tmp5_ = g->children;
#line 157 "../src/NodeGroup.vala"
		it = _tmp5_;
#line 1398 "NodeGroup.c"
		{
			gboolean _tmp6_ = FALSE;
#line 157 "../src/NodeGroup.vala"
			_tmp6_ = TRUE;
#line 157 "../src/NodeGroup.vala"
			while (TRUE) {
#line 1405 "NodeGroup.c"
				xmlNode* _tmp9_;
				xmlNode* _tmp10_;
#line 157 "../src/NodeGroup.vala"
				if (!_tmp6_) {
#line 1410 "NodeGroup.c"
					xmlNode* _tmp7_;
					xmlNode* _tmp8_;
#line 157 "../src/NodeGroup.vala"
					_tmp7_ = it;
#line 157 "../src/NodeGroup.vala"
					_tmp8_ = _tmp7_->next;
#line 157 "../src/NodeGroup.vala"
					it = _tmp8_;
#line 1419 "NodeGroup.c"
				}
#line 157 "../src/NodeGroup.vala"
				_tmp6_ = FALSE;
#line 157 "../src/NodeGroup.vala"
				_tmp9_ = it;
#line 157 "../src/NodeGroup.vala"
				if (!(_tmp9_ != NULL)) {
#line 157 "../src/NodeGroup.vala"
					break;
#line 1429 "NodeGroup.c"
				}
#line 158 "../src/NodeGroup.vala"
				_tmp10_ = it;
#line 158 "../src/NodeGroup.vala"
				if (_tmp10_->type == XML_ELEMENT_NODE) {
#line 1435 "NodeGroup.c"
					xmlNode* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					GQuark _tmp15_ = 0U;
#line 159 "../src/NodeGroup.vala"
					static GQuark _tmp14_label0 = 0;
#line 159 "../src/NodeGroup.vala"
					static GQuark _tmp14_label1 = 0;
#line 159 "../src/NodeGroup.vala"
					_tmp11_ = it;
#line 159 "../src/NodeGroup.vala"
					_tmp12_ = _tmp11_->name;
#line 159 "../src/NodeGroup.vala"
					_tmp13_ = _tmp12_;
#line 159 "../src/NodeGroup.vala"
					_tmp15_ = (NULL == _tmp13_) ? 0 : g_quark_from_string (_tmp13_);
#line 159 "../src/NodeGroup.vala"
					if (_tmp15_ == ((0 != _tmp14_label0) ? _tmp14_label0 : (_tmp14_label0 = g_quark_from_static_string ("node")))) {
#line 159 "../src/NodeGroup.vala"
						switch (0) {
#line 1456 "NodeGroup.c"
							default:
							{
								xmlNode* _tmp16_;
#line 160 "../src/NodeGroup.vala"
								_tmp16_ = it;
#line 160 "../src/NodeGroup.vala"
								node_group_load_node (self, da, _tmp16_);
#line 160 "../src/NodeGroup.vala"
								break;
#line 1466 "NodeGroup.c"
							}
						}
					} else if (_tmp15_ == ((0 != _tmp14_label1) ? _tmp14_label1 : (_tmp14_label1 = g_quark_from_static_string ("groupnote")))) {
#line 159 "../src/NodeGroup.vala"
						switch (0) {
#line 1472 "NodeGroup.c"
							default:
							{
								xmlNode* _tmp17_;
#line 161 "../src/NodeGroup.vala"
								_tmp17_ = it;
#line 161 "../src/NodeGroup.vala"
								node_group_load_note (self, _tmp17_);
#line 161 "../src/NodeGroup.vala"
								break;
#line 1482 "NodeGroup.c"
							}
						}
					}
				}
			}
		}
	}
#line 150 "../src/NodeGroup.vala"
	_g_free0 (c);
#line 1492 "NodeGroup.c"
}

static void
node_group_load_node (NodeGroup* self,
                      DrawArea* da,
                      xmlNode* n)
{
	gchar* i = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 168 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/NodeGroup.vala"
	g_return_if_fail (da != NULL);
#line 169 "../src/NodeGroup.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "id");
#line 169 "../src/NodeGroup.vala"
	i = _tmp0_;
#line 170 "../src/NodeGroup.vala"
	_tmp1_ = i;
#line 170 "../src/NodeGroup.vala"
	if (_tmp1_ != NULL) {
#line 1515 "NodeGroup.c"
		gint id = 0;
		const gchar* _tmp2_;
		Node* node = NULL;
		GArray* _tmp3_;
		GArray* _tmp4_;
		Node* _tmp5_;
		Node* _tmp6_;
		Node* _tmp7_;
#line 171 "../src/NodeGroup.vala"
		_tmp2_ = i;
#line 171 "../src/NodeGroup.vala"
		id = atoi (_tmp2_);
#line 172 "../src/NodeGroup.vala"
		_tmp3_ = draw_area_get_nodes (da);
#line 172 "../src/NodeGroup.vala"
		_tmp4_ = _tmp3_;
#line 172 "../src/NodeGroup.vala"
		_tmp5_ = draw_area_get_node (da, _tmp4_, id);
#line 172 "../src/NodeGroup.vala"
		_tmp6_ = _tmp5_;
#line 172 "../src/NodeGroup.vala"
		_g_array_unref0 (_tmp4_);
#line 172 "../src/NodeGroup.vala"
		node = _tmp6_;
#line 173 "../src/NodeGroup.vala"
		_tmp7_ = node;
#line 173 "../src/NodeGroup.vala"
		if (_tmp7_ != NULL) {
#line 1544 "NodeGroup.c"
			Node* _tmp8_;
			GArray* _tmp9_;
			Node* _tmp10_;
			Node* _tmp11_;
#line 174 "../src/NodeGroup.vala"
			_tmp8_ = node;
#line 174 "../src/NodeGroup.vala"
			node_set_group (_tmp8_, TRUE);
#line 175 "../src/NodeGroup.vala"
			_tmp9_ = self->priv->_nodes;
#line 175 "../src/NodeGroup.vala"
			_tmp10_ = node;
#line 175 "../src/NodeGroup.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 175 "../src/NodeGroup.vala"
			g_array_append_val (_tmp9_, _tmp11_);
#line 1561 "NodeGroup.c"
		}
#line 170 "../src/NodeGroup.vala"
		_g_object_unref0 (node);
#line 1565 "NodeGroup.c"
	}
#line 168 "../src/NodeGroup.vala"
	_g_free0 (i);
#line 1569 "NodeGroup.c"
}

static void
node_group_load_note (NodeGroup* self,
                      xmlNode* n)
{
	gboolean _tmp0_ = FALSE;
	xmlNode* _tmp1_;
#line 181 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/NodeGroup.vala"
	_tmp1_ = n->children;
#line 182 "../src/NodeGroup.vala"
	if (_tmp1_ != NULL) {
#line 1584 "NodeGroup.c"
		xmlNode* _tmp2_;
#line 182 "../src/NodeGroup.vala"
		_tmp2_ = n->children;
#line 182 "../src/NodeGroup.vala"
		_tmp0_ = _tmp2_->type == XML_TEXT_NODE;
#line 1590 "NodeGroup.c"
	} else {
#line 182 "../src/NodeGroup.vala"
		_tmp0_ = FALSE;
#line 1594 "NodeGroup.c"
	}
#line 182 "../src/NodeGroup.vala"
	if (_tmp0_) {
#line 1598 "NodeGroup.c"
		xmlNode* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 183 "../src/NodeGroup.vala"
		_tmp3_ = n->children;
#line 183 "../src/NodeGroup.vala"
		_tmp4_ = (gchar*) xmlNodeGetContent (_tmp3_);
#line 183 "../src/NodeGroup.vala"
		_tmp5_ = _tmp4_;
#line 183 "../src/NodeGroup.vala"
		node_group_set_note (self, _tmp5_);
#line 183 "../src/NodeGroup.vala"
		_g_free0 (_tmp5_);
#line 1612 "NodeGroup.c"
	}
}

void
node_group_draw (NodeGroup* self,
                 cairo_t* ctx,
                 Theme* theme,
                 gboolean exporting)
{
	GArray* points = NULL;
	GArray* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GroupMode _tmp2_;
	gboolean selected = FALSE;
	gdouble alpha = 0.0;
	GdkRGBA* _tmp20_ = NULL;
	GArray* _tmp24_;
	GdkRGBA _tmp25_;
#line 188 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/NodeGroup.vala"
	g_return_if_fail (ctx != NULL);
#line 188 "../src/NodeGroup.vala"
	g_return_if_fail (theme != NULL);
#line 189 "../src/NodeGroup.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
#line 189 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
#line 189 "../src/NodeGroup.vala"
	points = _tmp0_;
#line 190 "../src/NodeGroup.vala"
	_tmp2_ = self->priv->_mode;
#line 190 "../src/NodeGroup.vala"
	if (_tmp2_ == GROUP_MODE_SELECTED) {
#line 190 "../src/NodeGroup.vala"
		_tmp1_ = !exporting;
#line 1649 "NodeGroup.c"
	} else {
#line 190 "../src/NodeGroup.vala"
		_tmp1_ = FALSE;
#line 1653 "NodeGroup.c"
	}
#line 190 "../src/NodeGroup.vala"
	selected = _tmp1_;
#line 191 "../src/NodeGroup.vala"
	alpha = 0.0;
#line 1659 "NodeGroup.c"
	{
		gint i = 0;
#line 192 "../src/NodeGroup.vala"
		i = 0;
#line 1664 "NodeGroup.c"
		{
			gboolean _tmp3_ = FALSE;
#line 192 "../src/NodeGroup.vala"
			_tmp3_ = TRUE;
#line 192 "../src/NodeGroup.vala"
			while (TRUE) {
#line 1671 "NodeGroup.c"
				GArray* _tmp5_;
				GArray* _tmp6_;
				Node* _tmp7_;
				GArray* _tmp8_;
				Node* _tmp9_;
				GArray* _tmp10_;
				gdouble _tmp11_ = 0.0;
				GArray* _tmp12_;
				Node* _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_;
#line 192 "../src/NodeGroup.vala"
				if (!_tmp3_) {
#line 1685 "NodeGroup.c"
					gint _tmp4_;
#line 192 "../src/NodeGroup.vala"
					_tmp4_ = i;
#line 192 "../src/NodeGroup.vala"
					i = _tmp4_ + 1;
#line 1691 "NodeGroup.c"
				}
#line 192 "../src/NodeGroup.vala"
				_tmp3_ = FALSE;
#line 192 "../src/NodeGroup.vala"
				_tmp5_ = self->priv->_nodes;
#line 192 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp5_->len)) {
#line 192 "../src/NodeGroup.vala"
					break;
#line 1701 "NodeGroup.c"
				}
#line 193 "../src/NodeGroup.vala"
				_tmp6_ = self->priv->_nodes;
#line 193 "../src/NodeGroup.vala"
				_tmp7_ = g_array_index (_tmp6_, Node*, (guint) i);
#line 193 "../src/NodeGroup.vala"
				_tmp8_ = self->priv->_nodes;
#line 193 "../src/NodeGroup.vala"
				_tmp9_ = g_array_index (_tmp8_, Node*, (guint) i);
#line 193 "../src/NodeGroup.vala"
				_tmp10_ = points;
#line 193 "../src/NodeGroup.vala"
				node_group_get_tree_points (_tmp7_, _tmp9_, _tmp10_);
#line 194 "../src/NodeGroup.vala"
				_tmp12_ = self->priv->_nodes;
#line 194 "../src/NodeGroup.vala"
				_tmp13_ = g_array_index (_tmp12_, Node*, (guint) i);
#line 194 "../src/NodeGroup.vala"
				_tmp14_ = node_get_alpha (_tmp13_);
#line 194 "../src/NodeGroup.vala"
				_tmp15_ = _tmp14_;
#line 194 "../src/NodeGroup.vala"
				if (_tmp15_ > alpha) {
#line 1725 "NodeGroup.c"
					GArray* _tmp16_;
					Node* _tmp17_;
					gdouble _tmp18_;
					gdouble _tmp19_;
#line 194 "../src/NodeGroup.vala"
					_tmp16_ = self->priv->_nodes;
#line 194 "../src/NodeGroup.vala"
					_tmp17_ = g_array_index (_tmp16_, Node*, (guint) i);
#line 194 "../src/NodeGroup.vala"
					_tmp18_ = node_get_alpha (_tmp17_);
#line 194 "../src/NodeGroup.vala"
					_tmp19_ = _tmp18_;
#line 194 "../src/NodeGroup.vala"
					_tmp11_ = _tmp19_;
#line 1740 "NodeGroup.c"
				} else {
#line 194 "../src/NodeGroup.vala"
					_tmp11_ = alpha;
#line 1744 "NodeGroup.c"
				}
#line 194 "../src/NodeGroup.vala"
				alpha = _tmp11_;
#line 1748 "NodeGroup.c"
			}
		}
	}
#line 196 "../src/NodeGroup.vala"
	if (selected) {
#line 1754 "NodeGroup.c"
		GdkRGBA* _tmp21_;
#line 196 "../src/NodeGroup.vala"
		_tmp21_ = theme_get_color (theme, "nodesel_background");
#line 196 "../src/NodeGroup.vala"
		__vala_GdkRGBA_free0 (_tmp20_);
#line 196 "../src/NodeGroup.vala"
		_tmp20_ = _tmp21_;
#line 1762 "NodeGroup.c"
	} else {
		GdkRGBA _tmp22_;
		GdkRGBA* _tmp23_;
#line 196 "../src/NodeGroup.vala"
		_tmp22_ = self->priv->_color;
#line 196 "../src/NodeGroup.vala"
		_tmp23_ = __vala_GdkRGBA_copy0 (&_tmp22_);
#line 196 "../src/NodeGroup.vala"
		__vala_GdkRGBA_free0 (_tmp20_);
#line 196 "../src/NodeGroup.vala"
		_tmp20_ = _tmp23_;
#line 1774 "NodeGroup.c"
	}
#line 196 "../src/NodeGroup.vala"
	_tmp24_ = points;
#line 196 "../src/NodeGroup.vala"
	_tmp25_ = *_tmp20_;
#line 196 "../src/NodeGroup.vala"
	node_group_draw_cloud (ctx, &_tmp25_, selected, alpha, _tmp24_);
#line 188 "../src/NodeGroup.vala"
	__vala_GdkRGBA_free0 (_tmp20_);
#line 188 "../src/NodeGroup.vala"
	_g_array_unref0 (points);
#line 1786 "NodeGroup.c"
}

void
node_group_draw_tree (cairo_t* ctx,
                      Node* node,
                      Theme* theme)
{
	GArray* points = NULL;
	GArray* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
#line 200 "../src/NodeGroup.vala"
	g_return_if_fail (ctx != NULL);
#line 200 "../src/NodeGroup.vala"
	g_return_if_fail (node != NULL);
#line 200 "../src/NodeGroup.vala"
	g_return_if_fail (theme != NULL);
#line 201 "../src/NodeGroup.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
#line 201 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
#line 201 "../src/NodeGroup.vala"
	points = _tmp0_;
#line 202 "../src/NodeGroup.vala"
	node_group_get_tree_points (node, node, points);
#line 203 "../src/NodeGroup.vala"
	_tmp1_ = node_get_link_color (node);
#line 203 "../src/NodeGroup.vala"
	_tmp2_ = _tmp1_;
#line 203 "../src/NodeGroup.vala"
	_tmp3_ = node_get_alpha (node);
#line 203 "../src/NodeGroup.vala"
	_tmp4_ = _tmp3_;
#line 203 "../src/NodeGroup.vala"
	_tmp5_ = *_tmp2_;
#line 203 "../src/NodeGroup.vala"
	node_group_draw_cloud (ctx, &_tmp5_, FALSE, _tmp4_, points);
#line 200 "../src/NodeGroup.vala"
	_g_array_unref0 (points);
#line 1829 "NodeGroup.c"
}

static void
node_group_draw_cloud (cairo_t* ctx,
                       GdkRGBA* color,
                       gboolean selected,
                       gdouble alpha,
                       GArray* points)
{
	GArray* hull = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	GdkRGBA _tmp3_;
	GArray* _tmp4_;
	GArray* _tmp5_;
#line 207 "../src/NodeGroup.vala"
	g_return_if_fail (ctx != NULL);
#line 207 "../src/NodeGroup.vala"
	g_return_if_fail (color != NULL);
#line 207 "../src/NodeGroup.vala"
	g_return_if_fail (points != NULL);
#line 210 "../src/NodeGroup.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (NodePoint*));
#line 210 "../src/NodeGroup.vala"
	g_array_set_clear_func (_tmp0_, (GDestroyNotify) _vala_NodePoint_free_function_content_of);
#line 210 "../src/NodeGroup.vala"
	hull = _tmp0_;
#line 211 "../src/NodeGroup.vala"
	_tmp1_ = hull;
#line 211 "../src/NodeGroup.vala"
	node_group_get_convex_hull (points, _tmp1_);
#line 214 "../src/NodeGroup.vala"
	_tmp2_ = hull;
#line 214 "../src/NodeGroup.vala"
	if (_tmp2_->len == ((guint) 0)) {
#line 214 "../src/NodeGroup.vala"
		_g_array_unref0 (hull);
#line 214 "../src/NodeGroup.vala"
		return;
#line 1870 "NodeGroup.c"
	}
#line 217 "../src/NodeGroup.vala"
	_tmp3_ = *color;
#line 217 "../src/NodeGroup.vala"
	utils_set_context_color_with_alpha (ctx, &_tmp3_, alpha * 0.3);
#line 218 "../src/NodeGroup.vala"
	_tmp4_ = hull;
#line 218 "../src/NodeGroup.vala"
	_tmp5_ = hull;
#line 218 "../src/NodeGroup.vala"
	cairo_move_to (ctx, (*g_array_index (_tmp4_, NodePoint*, (guint) 0)).x, (*g_array_index (_tmp5_, NodePoint*, (guint) 0)).y);
#line 1882 "NodeGroup.c"
	{
		gint i = 0;
#line 219 "../src/NodeGroup.vala"
		i = 0;
#line 1887 "NodeGroup.c"
		{
			gboolean _tmp6_ = FALSE;
#line 219 "../src/NodeGroup.vala"
			_tmp6_ = TRUE;
#line 219 "../src/NodeGroup.vala"
			while (TRUE) {
#line 1894 "NodeGroup.c"
				GArray* _tmp8_;
				GArray* _tmp9_;
				GArray* _tmp10_;
#line 219 "../src/NodeGroup.vala"
				if (!_tmp6_) {
#line 1900 "NodeGroup.c"
					gint _tmp7_;
#line 219 "../src/NodeGroup.vala"
					_tmp7_ = i;
#line 219 "../src/NodeGroup.vala"
					i = _tmp7_ + 1;
#line 1906 "NodeGroup.c"
				}
#line 219 "../src/NodeGroup.vala"
				_tmp6_ = FALSE;
#line 219 "../src/NodeGroup.vala"
				_tmp8_ = hull;
#line 219 "../src/NodeGroup.vala"
				if (!(((guint) i) < _tmp8_->len)) {
#line 219 "../src/NodeGroup.vala"
					break;
#line 1916 "NodeGroup.c"
				}
#line 220 "../src/NodeGroup.vala"
				_tmp9_ = hull;
#line 220 "../src/NodeGroup.vala"
				_tmp10_ = hull;
#line 220 "../src/NodeGroup.vala"
				cairo_line_to (ctx, (*g_array_index (_tmp9_, NodePoint*, (guint) i)).x, (*g_array_index (_tmp10_, NodePoint*, (guint) i)).y);
#line 1924 "NodeGroup.c"
			}
		}
	}
#line 222 "../src/NodeGroup.vala"
	cairo_close_path (ctx);
#line 225 "../src/NodeGroup.vala"
	if (selected) {
#line 1932 "NodeGroup.c"
		GdkRGBA _tmp11_;
#line 226 "../src/NodeGroup.vala"
		cairo_fill_preserve (ctx);
#line 227 "../src/NodeGroup.vala"
		_tmp11_ = *color;
#line 227 "../src/NodeGroup.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp11_, alpha);
#line 228 "../src/NodeGroup.vala"
		cairo_stroke (ctx);
#line 1942 "NodeGroup.c"
	} else {
#line 230 "../src/NodeGroup.vala"
		cairo_fill (ctx);
#line 1946 "NodeGroup.c"
	}
#line 207 "../src/NodeGroup.vala"
	_g_array_unref0 (hull);
#line 1950 "NodeGroup.c"
}

void
node_group_add_node_points (GArray* points,
                            Node* node,
                            gint pad)
{
	gdouble x1 = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble y1 = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble x2 = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble y2 = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	NodePoint _tmp20_ = {0};
	NodePoint* _tmp21_;
	NodePoint _tmp22_ = {0};
	NodePoint* _tmp23_;
	NodePoint _tmp24_ = {0};
	NodePoint* _tmp25_;
	NodePoint _tmp26_ = {0};
	NodePoint* _tmp27_;
#line 236 "../src/NodeGroup.vala"
	g_return_if_fail (points != NULL);
#line 236 "../src/NodeGroup.vala"
	g_return_if_fail (node != NULL);
#line 238 "../src/NodeGroup.vala"
	_tmp0_ = node_get_posx (node);
#line 238 "../src/NodeGroup.vala"
	_tmp1_ = _tmp0_;
#line 238 "../src/NodeGroup.vala"
	x1 = _tmp1_ - pad;
#line 239 "../src/NodeGroup.vala"
	_tmp2_ = node_get_posy (node);
#line 239 "../src/NodeGroup.vala"
	_tmp3_ = _tmp2_;
#line 239 "../src/NodeGroup.vala"
	y1 = _tmp3_ - pad;
#line 240 "../src/NodeGroup.vala"
	_tmp4_ = node_get_posx (node);
#line 240 "../src/NodeGroup.vala"
	_tmp5_ = _tmp4_;
#line 240 "../src/NodeGroup.vala"
	_tmp6_ = node_get_width (node);
#line 240 "../src/NodeGroup.vala"
	_tmp7_ = _tmp6_;
#line 240 "../src/NodeGroup.vala"
	x2 = (_tmp5_ + _tmp7_) + pad;
#line 241 "../src/NodeGroup.vala"
	_tmp8_ = node_get_posy (node);
#line 241 "../src/NodeGroup.vala"
	_tmp9_ = _tmp8_;
#line 241 "../src/NodeGroup.vala"
	_tmp10_ = node_get_height (node);
#line 241 "../src/NodeGroup.vala"
	_tmp11_ = _tmp10_;
#line 241 "../src/NodeGroup.vala"
	y2 = (_tmp9_ + _tmp11_) + pad;
#line 243 "../src/NodeGroup.vala"
	_tmp12_ = node_get_folded (node);
#line 243 "../src/NodeGroup.vala"
	_tmp13_ = _tmp12_;
#line 243 "../src/NodeGroup.vala"
	if (_tmp13_) {
#line 2026 "NodeGroup.c"
		gdouble fx = 0.0;
		gdouble fy = 0.0;
		gdouble fw = 0.0;
		gdouble fh = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		gdouble _tmp17_ = 0.0;
		NodeSide _tmp18_;
		NodeSide _tmp19_;
#line 245 "../src/NodeGroup.vala"
		node_fold_bbox (node, &_tmp14_, &_tmp15_, &_tmp16_, &_tmp17_);
#line 245 "../src/NodeGroup.vala"
		fx = _tmp14_;
#line 245 "../src/NodeGroup.vala"
		fy = _tmp15_;
#line 245 "../src/NodeGroup.vala"
		fw = _tmp16_;
#line 245 "../src/NodeGroup.vala"
		fh = _tmp17_;
#line 246 "../src/NodeGroup.vala"
		_tmp18_ = node_get_side (node);
#line 246 "../src/NodeGroup.vala"
		_tmp19_ = _tmp18_;
#line 246 "../src/NodeGroup.vala"
		switch (_tmp19_) {
#line 246 "../src/NodeGroup.vala"
			case NODE_SIDE_LEFT:
#line 2055 "NodeGroup.c"
			{
#line 247 "../src/NodeGroup.vala"
				x1 = fx - pad;
#line 247 "../src/NodeGroup.vala"
				break;
#line 2061 "NodeGroup.c"
			}
#line 246 "../src/NodeGroup.vala"
			case NODE_SIDE_RIGHT:
#line 2065 "NodeGroup.c"
			{
#line 248 "../src/NodeGroup.vala"
				x2 = (fx + fw) + pad;
#line 248 "../src/NodeGroup.vala"
				break;
#line 2071 "NodeGroup.c"
			}
#line 246 "../src/NodeGroup.vala"
			case NODE_SIDE_TOP:
#line 2075 "NodeGroup.c"
			{
#line 249 "../src/NodeGroup.vala"
				y1 = fy - pad;
#line 249 "../src/NodeGroup.vala"
				break;
#line 2081 "NodeGroup.c"
			}
#line 246 "../src/NodeGroup.vala"
			case NODE_SIDE_BOTTOM:
#line 2085 "NodeGroup.c"
			{
#line 250 "../src/NodeGroup.vala"
				y2 = (fy + fh) + pad;
#line 250 "../src/NodeGroup.vala"
				break;
#line 2091 "NodeGroup.c"
			}
			default:
#line 246 "../src/NodeGroup.vala"
			break;
#line 2096 "NodeGroup.c"
		}
	}
#line 254 "../src/NodeGroup.vala"
	node_point_init (&_tmp20_, x1, y1);
#line 254 "../src/NodeGroup.vala"
	_tmp21_ = _node_point_dup0 (&_tmp20_);
#line 254 "../src/NodeGroup.vala"
	g_array_append_val (points, _tmp21_);
#line 255 "../src/NodeGroup.vala"
	node_point_init (&_tmp22_, x2, y1);
#line 255 "../src/NodeGroup.vala"
	_tmp23_ = _node_point_dup0 (&_tmp22_);
#line 255 "../src/NodeGroup.vala"
	g_array_append_val (points, _tmp23_);
#line 256 "../src/NodeGroup.vala"
	node_point_init (&_tmp24_, x1, y2);
#line 256 "../src/NodeGroup.vala"
	_tmp25_ = _node_point_dup0 (&_tmp24_);
#line 256 "../src/NodeGroup.vala"
	g_array_append_val (points, _tmp25_);
#line 257 "../src/NodeGroup.vala"
	node_point_init (&_tmp26_, x2, y2);
#line 257 "../src/NodeGroup.vala"
	_tmp27_ = _node_point_dup0 (&_tmp26_);
#line 257 "../src/NodeGroup.vala"
	g_array_append_val (points, _tmp27_);
#line 2123 "NodeGroup.c"
}

void
node_group_get_tree_points (Node* origin,
                            Node* node,
                            GArray* points)
{
	Node* _tmp0_;
	Node* _tmp1_;
	gboolean _tmp2_;
#line 262 "../src/NodeGroup.vala"
	g_return_if_fail (origin != NULL);
#line 262 "../src/NodeGroup.vala"
	g_return_if_fail (node != NULL);
#line 262 "../src/NodeGroup.vala"
	g_return_if_fail (points != NULL);
#line 263 "../src/NodeGroup.vala"
	_tmp0_ = node_folded_ancestor (node);
#line 263 "../src/NodeGroup.vala"
	_tmp1_ = _tmp0_;
#line 263 "../src/NodeGroup.vala"
	_tmp2_ = _tmp1_ == NULL;
#line 263 "../src/NodeGroup.vala"
	_g_object_unref0 (_tmp1_);
#line 263 "../src/NodeGroup.vala"
	if (_tmp2_) {
#line 2150 "NodeGroup.c"
		gint pad = 0;
#line 264 "../src/NodeGroup.vala"
		pad = node_groups_between (node, origin) * 5;
#line 265 "../src/NodeGroup.vala"
		node_group_add_node_points (points, node, pad);
#line 2156 "NodeGroup.c"
		{
			gint i = 0;
#line 266 "../src/NodeGroup.vala"
			i = 0;
#line 2161 "NodeGroup.c"
			{
				gboolean _tmp3_ = FALSE;
#line 266 "../src/NodeGroup.vala"
				_tmp3_ = TRUE;
#line 266 "../src/NodeGroup.vala"
				while (TRUE) {
#line 2168 "NodeGroup.c"
					GArray* _tmp5_;
					GArray* _tmp6_;
					gboolean _tmp7_;
					GArray* _tmp8_;
					GArray* _tmp9_;
					Node* _tmp10_;
#line 266 "../src/NodeGroup.vala"
					if (!_tmp3_) {
#line 2177 "NodeGroup.c"
						gint _tmp4_;
#line 266 "../src/NodeGroup.vala"
						_tmp4_ = i;
#line 266 "../src/NodeGroup.vala"
						i = _tmp4_ + 1;
#line 2183 "NodeGroup.c"
					}
#line 266 "../src/NodeGroup.vala"
					_tmp3_ = FALSE;
#line 266 "../src/NodeGroup.vala"
					_tmp5_ = node_children (node);
#line 266 "../src/NodeGroup.vala"
					_tmp6_ = _tmp5_;
#line 266 "../src/NodeGroup.vala"
					_tmp7_ = !(((guint) i) < _tmp6_->len);
#line 266 "../src/NodeGroup.vala"
					_g_array_unref0 (_tmp6_);
#line 266 "../src/NodeGroup.vala"
					if (_tmp7_) {
#line 266 "../src/NodeGroup.vala"
						break;
#line 2199 "NodeGroup.c"
					}
#line 267 "../src/NodeGroup.vala"
					_tmp8_ = node_children (node);
#line 267 "../src/NodeGroup.vala"
					_tmp9_ = _tmp8_;
#line 267 "../src/NodeGroup.vala"
					_tmp10_ = g_array_index (_tmp9_, Node*, (guint) i);
#line 267 "../src/NodeGroup.vala"
					node_group_get_tree_points (origin, _tmp10_, points);
#line 267 "../src/NodeGroup.vala"
					_g_array_unref0 (_tmp9_);
#line 2211 "NodeGroup.c"
				}
			}
		}
	}
}

void
node_group_get_convex_hull (GArray* points,
                            GArray* hull)
{
	gint n = 0;
	gint l = 0;
	gint p = 0;
#line 273 "../src/NodeGroup.vala"
	g_return_if_fail (points != NULL);
#line 273 "../src/NodeGroup.vala"
	g_return_if_fail (hull != NULL);
#line 275 "../src/NodeGroup.vala"
	n = (gint) points->len;
#line 277 "../src/NodeGroup.vala"
	if (n == 0) {
#line 277 "../src/NodeGroup.vala"
		return;
#line 2235 "NodeGroup.c"
	}
#line 280 "../src/NodeGroup.vala"
	l = 0;
#line 2239 "NodeGroup.c"
	{
		gint i = 0;
#line 281 "../src/NodeGroup.vala"
		i = 1;
#line 2244 "NodeGroup.c"
		{
			gboolean _tmp0_ = FALSE;
#line 281 "../src/NodeGroup.vala"
			_tmp0_ = TRUE;
#line 281 "../src/NodeGroup.vala"
			while (TRUE) {
#line 281 "../src/NodeGroup.vala"
				if (!_tmp0_) {
#line 2253 "NodeGroup.c"
					gint _tmp1_;
#line 281 "../src/NodeGroup.vala"
					_tmp1_ = i;
#line 281 "../src/NodeGroup.vala"
					i = _tmp1_ + 1;
#line 2259 "NodeGroup.c"
				}
#line 281 "../src/NodeGroup.vala"
				_tmp0_ = FALSE;
#line 281 "../src/NodeGroup.vala"
				if (!(i < n)) {
#line 281 "../src/NodeGroup.vala"
					break;
#line 2267 "NodeGroup.c"
				}
#line 282 "../src/NodeGroup.vala"
				if ((*g_array_index (points, NodePoint*, (guint) i)).x < (*g_array_index (points, NodePoint*, (guint) l)).x) {
#line 282 "../src/NodeGroup.vala"
					l = i;
#line 2273 "NodeGroup.c"
				}
			}
		}
	}
#line 285 "../src/NodeGroup.vala"
	p = l;
#line 2280 "NodeGroup.c"
	{
		gboolean _tmp2_ = FALSE;
#line 287 "../src/NodeGroup.vala"
		_tmp2_ = TRUE;
#line 287 "../src/NodeGroup.vala"
		while (TRUE) {
#line 2287 "NodeGroup.c"
			NodePoint* _tmp3_;
			gint q = 0;
#line 287 "../src/NodeGroup.vala"
			if (!_tmp2_) {
#line 294 "../src/NodeGroup.vala"
				if (!(p != l)) {
#line 294 "../src/NodeGroup.vala"
					break;
#line 2296 "NodeGroup.c"
				}
			}
#line 287 "../src/NodeGroup.vala"
			_tmp2_ = FALSE;
#line 288 "../src/NodeGroup.vala"
			_tmp3_ = _node_point_dup0 (g_array_index (points, NodePoint*, (guint) p));
#line 288 "../src/NodeGroup.vala"
			g_array_append_val (hull, _tmp3_);
#line 289 "../src/NodeGroup.vala"
			q = (p + 1) % n;
#line 2307 "NodeGroup.c"
			{
				gint i = 0;
#line 290 "../src/NodeGroup.vala"
				i = 0;
#line 2312 "NodeGroup.c"
				{
					gboolean _tmp4_ = FALSE;
#line 290 "../src/NodeGroup.vala"
					_tmp4_ = TRUE;
#line 290 "../src/NodeGroup.vala"
					while (TRUE) {
#line 2319 "NodeGroup.c"
						NodePoint _tmp6_;
						NodePoint _tmp7_;
						NodePoint _tmp8_;
#line 290 "../src/NodeGroup.vala"
						if (!_tmp4_) {
#line 2325 "NodeGroup.c"
							gint _tmp5_;
#line 290 "../src/NodeGroup.vala"
							_tmp5_ = i;
#line 290 "../src/NodeGroup.vala"
							i = _tmp5_ + 1;
#line 2331 "NodeGroup.c"
						}
#line 290 "../src/NodeGroup.vala"
						_tmp4_ = FALSE;
#line 290 "../src/NodeGroup.vala"
						if (!(i < n)) {
#line 290 "../src/NodeGroup.vala"
							break;
#line 2339 "NodeGroup.c"
						}
#line 291 "../src/NodeGroup.vala"
						_tmp6_ = *g_array_index (points, NodePoint*, (guint) p);
#line 291 "../src/NodeGroup.vala"
						_tmp7_ = *g_array_index (points, NodePoint*, (guint) i);
#line 291 "../src/NodeGroup.vala"
						_tmp8_ = *g_array_index (points, NodePoint*, (guint) q);
#line 291 "../src/NodeGroup.vala"
						if (node_group_calc_orientation (&_tmp6_, &_tmp7_, &_tmp8_) == 2) {
#line 291 "../src/NodeGroup.vala"
							q = i;
#line 2351 "NodeGroup.c"
						}
					}
				}
			}
#line 293 "../src/NodeGroup.vala"
			p = q;
#line 2358 "NodeGroup.c"
		}
	}
}

gint
node_group_calc_orientation (NodePoint* p,
                             NodePoint* q,
                             NodePoint* r)
{
	gdouble val = 0.0;
	NodePoint _tmp0_;
	NodePoint _tmp1_;
	NodePoint _tmp2_;
	NodePoint _tmp3_;
	NodePoint _tmp4_;
	NodePoint _tmp5_;
	NodePoint _tmp6_;
	NodePoint _tmp7_;
	gint _tmp8_ = 0;
	gint result;
#line 299 "../src/NodeGroup.vala"
	g_return_val_if_fail (p != NULL, 0);
#line 299 "../src/NodeGroup.vala"
	g_return_val_if_fail (q != NULL, 0);
#line 299 "../src/NodeGroup.vala"
	g_return_val_if_fail (r != NULL, 0);
#line 300 "../src/NodeGroup.vala"
	_tmp0_ = *q;
#line 300 "../src/NodeGroup.vala"
	_tmp1_ = *p;
#line 300 "../src/NodeGroup.vala"
	_tmp2_ = *r;
#line 300 "../src/NodeGroup.vala"
	_tmp3_ = *q;
#line 300 "../src/NodeGroup.vala"
	_tmp4_ = *q;
#line 300 "../src/NodeGroup.vala"
	_tmp5_ = *p;
#line 300 "../src/NodeGroup.vala"
	_tmp6_ = *r;
#line 300 "../src/NodeGroup.vala"
	_tmp7_ = *q;
#line 300 "../src/NodeGroup.vala"
	val = ((_tmp0_.y - _tmp1_.y) * (_tmp2_.x - _tmp3_.x)) - ((_tmp4_.x - _tmp5_.x) * (_tmp6_.y - _tmp7_.y));
#line 301 "../src/NodeGroup.vala"
	if (val == ((gdouble) 0)) {
#line 301 "../src/NodeGroup.vala"
		result = 0;
#line 301 "../src/NodeGroup.vala"
		return result;
#line 2409 "NodeGroup.c"
	}
#line 302 "../src/NodeGroup.vala"
	if (val > ((gdouble) 0)) {
#line 302 "../src/NodeGroup.vala"
		_tmp8_ = 1;
#line 2415 "NodeGroup.c"
	} else {
#line 302 "../src/NodeGroup.vala"
		_tmp8_ = 2;
#line 2419 "NodeGroup.c"
	}
#line 302 "../src/NodeGroup.vala"
	result = _tmp8_;
#line 302 "../src/NodeGroup.vala"
	return result;
#line 2425 "NodeGroup.c"
}

GroupMode
node_group_get_mode (NodeGroup* self)
{
	GroupMode result;
#line 44 "../src/NodeGroup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/NodeGroup.vala"
	result = self->priv->_mode;
#line 44 "../src/NodeGroup.vala"
	return result;
#line 2438 "NodeGroup.c"
}

void
node_group_set_mode (NodeGroup* self,
                     GroupMode value)
{
#line 44 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/NodeGroup.vala"
	self->priv->_mode = value;
#line 2449 "NodeGroup.c"
}

void
node_group_get_color (NodeGroup* self,
                      GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 45 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/NodeGroup.vala"
	_tmp0_ = self->priv->_color;
#line 45 "../src/NodeGroup.vala"
	*result = _tmp0_;
#line 45 "../src/NodeGroup.vala"
	return;
#line 2465 "NodeGroup.c"
}

void
node_group_set_color (NodeGroup* self,
                      GdkRGBA * value)
{
	GdkRGBA _tmp0_;
#line 45 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/NodeGroup.vala"
	_tmp0_ = *value;
#line 45 "../src/NodeGroup.vala"
	self->priv->_color = _tmp0_;
#line 2479 "NodeGroup.c"
}

const gchar*
node_group_get_note (NodeGroup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "../src/NodeGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/NodeGroup.vala"
	_tmp0_ = self->priv->_note;
#line 46 "../src/NodeGroup.vala"
	result = _tmp0_;
#line 46 "../src/NodeGroup.vala"
	return result;
#line 2495 "NodeGroup.c"
}

void
node_group_set_note (NodeGroup* self,
                     const gchar* value)
{
	gchar* _tmp0_;
#line 46 "../src/NodeGroup.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/NodeGroup.vala"
	_tmp0_ = g_strdup (value);
#line 46 "../src/NodeGroup.vala"
	_g_free0 (self->priv->_note);
#line 46 "../src/NodeGroup.vala"
	self->priv->_note = _tmp0_;
#line 2511 "NodeGroup.c"
}

GArray*
node_group_get_nodes (NodeGroup* self)
{
	GArray* result;
	GArray* _tmp0_;
#line 48 "../src/NodeGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/NodeGroup.vala"
	_tmp0_ = self->priv->_nodes;
#line 49 "../src/NodeGroup.vala"
	result = _tmp0_;
#line 49 "../src/NodeGroup.vala"
	return result;
#line 2527 "NodeGroup.c"
}

static void
value_node_group_init (GValue* value)
{
#line 40 "../src/NodeGroup.vala"
	value->data[0].v_pointer = NULL;
#line 2535 "NodeGroup.c"
}

static void
value_node_group_free_value (GValue* value)
{
#line 40 "../src/NodeGroup.vala"
	if (value->data[0].v_pointer) {
#line 40 "../src/NodeGroup.vala"
		node_group_unref (value->data[0].v_pointer);
#line 2545 "NodeGroup.c"
	}
}

static void
value_node_group_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 40 "../src/NodeGroup.vala"
	if (src_value->data[0].v_pointer) {
#line 40 "../src/NodeGroup.vala"
		dest_value->data[0].v_pointer = node_group_ref (src_value->data[0].v_pointer);
#line 2557 "NodeGroup.c"
	} else {
#line 40 "../src/NodeGroup.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2561 "NodeGroup.c"
	}
}

static gpointer
value_node_group_peek_pointer (const GValue* value)
{
#line 40 "../src/NodeGroup.vala"
	return value->data[0].v_pointer;
#line 2570 "NodeGroup.c"
}

static gchar*
value_node_group_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 40 "../src/NodeGroup.vala"
	if (collect_values[0].v_pointer) {
#line 2581 "NodeGroup.c"
		NodeGroup * object;
		object = collect_values[0].v_pointer;
#line 40 "../src/NodeGroup.vala"
		if (object->parent_instance.g_class == NULL) {
#line 40 "../src/NodeGroup.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2588 "NodeGroup.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 40 "../src/NodeGroup.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2592 "NodeGroup.c"
		}
#line 40 "../src/NodeGroup.vala"
		value->data[0].v_pointer = node_group_ref (object);
#line 2596 "NodeGroup.c"
	} else {
#line 40 "../src/NodeGroup.vala"
		value->data[0].v_pointer = NULL;
#line 2600 "NodeGroup.c"
	}
#line 40 "../src/NodeGroup.vala"
	return NULL;
#line 2604 "NodeGroup.c"
}

static gchar*
value_node_group_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	NodeGroup ** object_p;
	object_p = collect_values[0].v_pointer;
#line 40 "../src/NodeGroup.vala"
	if (!object_p) {
#line 40 "../src/NodeGroup.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2619 "NodeGroup.c"
	}
#line 40 "../src/NodeGroup.vala"
	if (!value->data[0].v_pointer) {
#line 40 "../src/NodeGroup.vala"
		*object_p = NULL;
#line 2625 "NodeGroup.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 40 "../src/NodeGroup.vala"
		*object_p = value->data[0].v_pointer;
#line 2629 "NodeGroup.c"
	} else {
#line 40 "../src/NodeGroup.vala"
		*object_p = node_group_ref (value->data[0].v_pointer);
#line 2633 "NodeGroup.c"
	}
#line 40 "../src/NodeGroup.vala"
	return NULL;
#line 2637 "NodeGroup.c"
}

GParamSpec*
param_spec_node_group (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecNodeGroup* spec;
#line 40 "../src/NodeGroup.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_NODE_GROUP), NULL);
#line 40 "../src/NodeGroup.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 40 "../src/NodeGroup.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 40 "../src/NodeGroup.vala"
	return G_PARAM_SPEC (spec);
#line 2656 "NodeGroup.c"
}

gpointer
value_get_node_group (const GValue* value)
{
#line 40 "../src/NodeGroup.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_GROUP), NULL);
#line 40 "../src/NodeGroup.vala"
	return value->data[0].v_pointer;
#line 2666 "NodeGroup.c"
}

void
value_set_node_group (GValue* value,
                      gpointer v_object)
{
	NodeGroup * old;
#line 40 "../src/NodeGroup.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_GROUP));
#line 40 "../src/NodeGroup.vala"
	old = value->data[0].v_pointer;
#line 40 "../src/NodeGroup.vala"
	if (v_object) {
#line 40 "../src/NodeGroup.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NODE_GROUP));
#line 40 "../src/NodeGroup.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 40 "../src/NodeGroup.vala"
		value->data[0].v_pointer = v_object;
#line 40 "../src/NodeGroup.vala"
		node_group_ref (value->data[0].v_pointer);
#line 2688 "NodeGroup.c"
	} else {
#line 40 "../src/NodeGroup.vala"
		value->data[0].v_pointer = NULL;
#line 2692 "NodeGroup.c"
	}
#line 40 "../src/NodeGroup.vala"
	if (old) {
#line 40 "../src/NodeGroup.vala"
		node_group_unref (old);
#line 2698 "NodeGroup.c"
	}
}

void
value_take_node_group (GValue* value,
                       gpointer v_object)
{
	NodeGroup * old;
#line 40 "../src/NodeGroup.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_GROUP));
#line 40 "../src/NodeGroup.vala"
	old = value->data[0].v_pointer;
#line 40 "../src/NodeGroup.vala"
	if (v_object) {
#line 40 "../src/NodeGroup.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NODE_GROUP));
#line 40 "../src/NodeGroup.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 40 "../src/NodeGroup.vala"
		value->data[0].v_pointer = v_object;
#line 2719 "NodeGroup.c"
	} else {
#line 40 "../src/NodeGroup.vala"
		value->data[0].v_pointer = NULL;
#line 2723 "NodeGroup.c"
	}
#line 40 "../src/NodeGroup.vala"
	if (old) {
#line 40 "../src/NodeGroup.vala"
		node_group_unref (old);
#line 2729 "NodeGroup.c"
	}
}

static void
node_group_class_init (NodeGroupClass * klass,
                       gpointer klass_data)
{
#line 40 "../src/NodeGroup.vala"
	node_group_parent_class = g_type_class_peek_parent (klass);
#line 40 "../src/NodeGroup.vala"
	((NodeGroupClass *) klass)->finalize = node_group_finalize;
#line 40 "../src/NodeGroup.vala"
	g_type_class_adjust_private_offset (klass, &NodeGroup_private_offset);
#line 2743 "NodeGroup.c"
}

static void
node_group_instance_init (NodeGroup * self,
                          gpointer klass)
{
	gchar* _tmp0_;
#line 40 "../src/NodeGroup.vala"
	self->priv = node_group_get_instance_private (self);
#line 44 "../src/NodeGroup.vala"
	self->priv->_mode = GROUP_MODE_NONE;
#line 46 "../src/NodeGroup.vala"
	_tmp0_ = g_strdup ("");
#line 46 "../src/NodeGroup.vala"
	self->priv->_note = _tmp0_;
#line 40 "../src/NodeGroup.vala"
	self->ref_count = 1;
#line 2761 "NodeGroup.c"
}

static void
node_group_finalize (NodeGroup * obj)
{
	NodeGroup * self;
#line 40 "../src/NodeGroup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NODE_GROUP, NodeGroup);
#line 40 "../src/NodeGroup.vala"
	g_signal_handlers_destroy (self);
#line 42 "../src/NodeGroup.vala"
	_g_array_unref0 (self->priv->_nodes);
#line 46 "../src/NodeGroup.vala"
	_g_free0 (self->priv->_note);
#line 2776 "NodeGroup.c"
}

static GType
node_group_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_node_group_init, value_node_group_free_value, value_node_group_copy_value, value_node_group_peek_pointer, "p", value_node_group_collect_value, "p", value_node_group_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (NodeGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) node_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NodeGroup), 0, (GInstanceInitFunc) node_group_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType node_group_type_id;
	node_group_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NodeGroup", &g_define_type_info, &g_define_type_fundamental_info, 0);
	NodeGroup_private_offset = g_type_add_instance_private (node_group_type_id, sizeof (NodeGroupPrivate));
	return node_group_type_id;
}

GType
node_group_get_type (void)
{
	static volatile gsize node_group_type_id__once = 0;
	if (g_once_init_enter (&node_group_type_id__once)) {
		GType node_group_type_id;
		node_group_type_id = node_group_get_type_once ();
		g_once_init_leave (&node_group_type_id__once, node_group_type_id);
	}
	return node_group_type_id__once;
}

gpointer
node_group_ref (gpointer instance)
{
	NodeGroup * self;
	self = instance;
#line 40 "../src/NodeGroup.vala"
	g_atomic_int_inc (&self->ref_count);
#line 40 "../src/NodeGroup.vala"
	return instance;
#line 2812 "NodeGroup.c"
}

void
node_group_unref (gpointer instance)
{
	NodeGroup * self;
	self = instance;
#line 40 "../src/NodeGroup.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 40 "../src/NodeGroup.vala"
		NODE_GROUP_GET_CLASS (self)->finalize (self);
#line 40 "../src/NodeGroup.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2826 "NodeGroup.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

