/* UndoNodeLayout.c generated by valac 0.56.14, the Vala compiler
 * generated from UndoNodeLayout.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_NODE_LAYOUT (undo_node_layout_get_type ())
#define UNDO_NODE_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_NODE_LAYOUT, UndoNodeLayout))
#define UNDO_NODE_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_NODE_LAYOUT, UndoNodeLayoutClass))
#define IS_UNDO_NODE_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_NODE_LAYOUT))
#define IS_UNDO_NODE_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_NODE_LAYOUT))
#define UNDO_NODE_LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_NODE_LAYOUT, UndoNodeLayoutClass))

typedef struct _UndoNodeLayout UndoNodeLayout;
typedef struct _UndoNodeLayoutClass UndoNodeLayoutClass;
typedef struct _UndoNodeLayoutPrivate UndoNodeLayoutPrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
enum  {
	UNDO_NODE_LAYOUT_0_PROPERTY,
	UNDO_NODE_LAYOUT_NUM_PROPERTIES
};
static GParamSpec* undo_node_layout_properties[UNDO_NODE_LAYOUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoNodeLayout {
	UndoItem parent_instance;
	UndoNodeLayoutPrivate * priv;
};

struct _UndoNodeLayoutClass {
	UndoItemClass parent_class;
};

struct _UndoNodeLayoutPrivate {
	gchar* _old_layout;
	gchar* _new_layout;
	Node* _root;
};

static gint UndoNodeLayout_private_offset;
static gpointer undo_node_layout_parent_class = NULL;

VALA_EXTERN GType undo_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoItem, g_object_unref)
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN GType undo_node_layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoNodeLayout, g_object_unref)
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN void undo_item_undo (UndoItem* self,
                     DrawArea* da);
VALA_EXTERN void undo_item_redo (UndoItem* self,
                     DrawArea* da);
VALA_EXTERN GType layout_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Layout, g_object_unref)
VALA_EXTERN UndoNodeLayout* undo_node_layout_new (Layout* old_layout,
                                      Layout* new_layout,
                                      Node* root_node);
VALA_EXTERN UndoNodeLayout* undo_node_layout_construct (GType object_type,
                                            Layout* old_layout,
                                            Layout* new_layout,
                                            Node* root_node);
VALA_EXTERN UndoItem* undo_item_new (const gchar* name);
VALA_EXTERN UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
VALA_EXTERN const gchar* layout_get_name (Layout* self);
static void undo_node_layout_real_undo (UndoItem* base,
                                 DrawArea* da);
VALA_EXTERN void draw_area_set_layout (DrawArea* self,
                           const gchar* name,
                           Node* root_node,
                           gboolean undoable);
static void undo_node_layout_real_redo (UndoItem* base,
                                 DrawArea* da);
static void undo_node_layout_finalize (GObject * obj);
static GType undo_node_layout_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
undo_node_layout_get_instance_private (UndoNodeLayout* self)
{
	return G_STRUCT_MEMBER_P (self, UndoNodeLayout_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../src/undo_actions/UndoNodeLayout.vala"
	return self ? g_object_ref (self) : NULL;
#line 183 "UndoNodeLayout.c"
}

UndoNodeLayout*
undo_node_layout_construct (GType object_type,
                            Layout* old_layout,
                            Layout* new_layout,
                            Node* root_node)
{
	UndoNodeLayout * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	Node* _tmp6_;
#line 29 "../src/undo_actions/UndoNodeLayout.vala"
	g_return_val_if_fail (old_layout != NULL, NULL);
#line 29 "../src/undo_actions/UndoNodeLayout.vala"
	g_return_val_if_fail (new_layout != NULL, NULL);
#line 30 "../src/undo_actions/UndoNodeLayout.vala"
	self = (UndoNodeLayout*) undo_item_construct (object_type, _ ("change layout"));
#line 31 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp0_ = layout_get_name (old_layout);
#line 31 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp1_ = _tmp0_;
#line 31 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 31 "../src/undo_actions/UndoNodeLayout.vala"
	_g_free0 (self->priv->_old_layout);
#line 31 "../src/undo_actions/UndoNodeLayout.vala"
	self->priv->_old_layout = _tmp2_;
#line 32 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp3_ = layout_get_name (new_layout);
#line 32 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp4_ = _tmp3_;
#line 32 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 32 "../src/undo_actions/UndoNodeLayout.vala"
	_g_free0 (self->priv->_new_layout);
#line 32 "../src/undo_actions/UndoNodeLayout.vala"
	self->priv->_new_layout = _tmp5_;
#line 33 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp6_ = _g_object_ref0 (root_node);
#line 33 "../src/undo_actions/UndoNodeLayout.vala"
	_g_object_unref0 (self->priv->_root);
#line 33 "../src/undo_actions/UndoNodeLayout.vala"
	self->priv->_root = _tmp6_;
#line 29 "../src/undo_actions/UndoNodeLayout.vala"
	return self;
#line 234 "UndoNodeLayout.c"
}

UndoNodeLayout*
undo_node_layout_new (Layout* old_layout,
                      Layout* new_layout,
                      Node* root_node)
{
#line 29 "../src/undo_actions/UndoNodeLayout.vala"
	return undo_node_layout_construct (TYPE_UNDO_NODE_LAYOUT, old_layout, new_layout, root_node);
#line 244 "UndoNodeLayout.c"
}

static void
undo_node_layout_real_undo (UndoItem* base,
                            DrawArea* da)
{
	UndoNodeLayout * self;
	const gchar* _tmp0_;
	Node* _tmp1_;
#line 37 "../src/undo_actions/UndoNodeLayout.vala"
	self = (UndoNodeLayout*) base;
#line 37 "../src/undo_actions/UndoNodeLayout.vala"
	g_return_if_fail (da != NULL);
#line 38 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp0_ = self->priv->_old_layout;
#line 38 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp1_ = self->priv->_root;
#line 38 "../src/undo_actions/UndoNodeLayout.vala"
	draw_area_set_layout (da, _tmp0_, _tmp1_, FALSE);
#line 39 "../src/undo_actions/UndoNodeLayout.vala"
	g_signal_emit_by_name (da, "loaded");
#line 266 "UndoNodeLayout.c"
}

static void
undo_node_layout_real_redo (UndoItem* base,
                            DrawArea* da)
{
	UndoNodeLayout * self;
	const gchar* _tmp0_;
	Node* _tmp1_;
#line 43 "../src/undo_actions/UndoNodeLayout.vala"
	self = (UndoNodeLayout*) base;
#line 43 "../src/undo_actions/UndoNodeLayout.vala"
	g_return_if_fail (da != NULL);
#line 44 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp0_ = self->priv->_new_layout;
#line 44 "../src/undo_actions/UndoNodeLayout.vala"
	_tmp1_ = self->priv->_root;
#line 44 "../src/undo_actions/UndoNodeLayout.vala"
	draw_area_set_layout (da, _tmp0_, _tmp1_, FALSE);
#line 45 "../src/undo_actions/UndoNodeLayout.vala"
	g_signal_emit_by_name (da, "loaded");
#line 288 "UndoNodeLayout.c"
}

static void
undo_node_layout_class_init (UndoNodeLayoutClass * klass,
                             gpointer klass_data)
{
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	undo_node_layout_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	g_type_class_adjust_private_offset (klass, &UndoNodeLayout_private_offset);
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_node_layout_real_undo;
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_node_layout_real_redo;
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	G_OBJECT_CLASS (klass)->finalize = undo_node_layout_finalize;
#line 305 "UndoNodeLayout.c"
}

static void
undo_node_layout_instance_init (UndoNodeLayout * self,
                                gpointer klass)
{
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	self->priv = undo_node_layout_get_instance_private (self);
#line 314 "UndoNodeLayout.c"
}

static void
undo_node_layout_finalize (GObject * obj)
{
	UndoNodeLayout * self;
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_NODE_LAYOUT, UndoNodeLayout);
#line 24 "../src/undo_actions/UndoNodeLayout.vala"
	_g_free0 (self->priv->_old_layout);
#line 25 "../src/undo_actions/UndoNodeLayout.vala"
	_g_free0 (self->priv->_new_layout);
#line 26 "../src/undo_actions/UndoNodeLayout.vala"
	_g_object_unref0 (self->priv->_root);
#line 22 "../src/undo_actions/UndoNodeLayout.vala"
	G_OBJECT_CLASS (undo_node_layout_parent_class)->finalize (obj);
#line 331 "UndoNodeLayout.c"
}

static GType
undo_node_layout_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UndoNodeLayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_node_layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoNodeLayout), 0, (GInstanceInitFunc) undo_node_layout_instance_init, NULL };
	GType undo_node_layout_type_id;
	undo_node_layout_type_id = g_type_register_static (TYPE_UNDO_ITEM, "UndoNodeLayout", &g_define_type_info, 0);
	UndoNodeLayout_private_offset = g_type_add_instance_private (undo_node_layout_type_id, sizeof (UndoNodeLayoutPrivate));
	return undo_node_layout_type_id;
}

GType
undo_node_layout_get_type (void)
{
	static volatile gsize undo_node_layout_type_id__once = 0;
	if (g_once_init_enter (&undo_node_layout_type_id__once)) {
		GType undo_node_layout_type_id;
		undo_node_layout_type_id = undo_node_layout_get_type_once ();
		g_once_init_leave (&undo_node_layout_type_id__once, undo_node_layout_type_id);
	}
	return undo_node_layout_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

